/*
########################################
              MIT License

Copyright (c) 2019 Marc Espin Sanz

License > https://github.com/Graviton-Code-Editor/Graviton-App/blob/master/LICENSE.md

#########################################
*/

let autocomplete = [
  {
    name: 'js',
    list: [
      { _name: 'above' },
      { _name: 'abs' },
      { _name: 'acos' },
      { _name: 'action' },
      { _name: 'addEventListener' },
      { _name: 'alert' },
      { _name: 'align' },
      { _name: 'aLinkcolor' },
      { _name: 'all' },
      { _name: 'Anchor' },
      { _name: 'anchor' },
      { _name: 'anchors' },
      { _name: 'appCodeName' },
      { _name: 'appCore' },
      { _name: 'appendChild' },
      { _name: 'Applet' },
      { _name: 'applets' },
      { _name: 'application' },
      { _name: 'apply' },
      { _name: 'appMinorVersion' },
      { _name: 'appName' },
      { _name: 'appVersion' },
      { _name: 'Area' },
      { _name: 'arguments' },
      { _name: 'arguments.callee' },
      { _name: 'arguments.caller' },
      { _name: 'arguments.length' },
      { _name: 'arity' },
      { _name: 'Array' },
      { _name: 'asin' },
      { _name: 'atan' },
      { _name: 'atan2' },
      { _name: 'atob' },
      { _name: 'attachEvent' },
      { _name: 'attributes' },
      { _name: 'availHeight' },
      { _name: 'availLeft' },
      { _name: 'availTop' },
      { _name: 'availWidth' },
      { _name: 'back' },
      { _name: 'background' },
      { _name: 'backgroundColor' },
      { _name: 'backgroundImage' },
      { _name: 'below' },
      { _name: 'bgColor' },
      { _name: 'big' },
      { _name: 'blink' },
      { _name: 'blob' },
      { _name: 'blur' },
      { _name: 'body' },
      { _name: 'bold' },
      { _name: 'boolean' },
      { _name: 'Boolean' },
      { _name: 'border' },
      { _name: 'borderBottomWidth' },
      { _name: 'borderColor' },
      { _name: 'borderLeftWidth' },
      { _name: 'borderRightWidth' },
      { _name: 'borderStyle' },
      { _name: 'borderTopWidth' },
      { _name: 'borderWidths' },
      { _name: 'bottom' },
      { _name: 'break' },
      { _name: 'btoa' },
      { _name: 'bufferDepth' },
      { _name: 'Button' },
      { _name: 'byte' },
      { _name: 'call' },
      { _name: 'captureEvents' },
      { _name: 'case' },
      { _name: 'catch' },
      { _name: 'ceil' },
      { _name: 'char' },
      { _name: 'characterSet' },
      { _name: 'charAt' },
      { _name: 'charCodeAt' },
      { _name: 'Checkbox' },
      { _name: 'checked' },
      { _name: 'childElementCount' },
      { _name: 'childNodes' },
      { _name: 'class' },
      { _name: 'classList' },
      { _name: 'classes' },
      { _name: 'className' },
      { _name: 'clear' },
      { _name: 'clearInterval' },
      { _name: 'clearTimeout' },
      { _name: 'click' },
      { _name: 'clientInformation' },
      { _name: 'clip' },
      { _name: 'clipboardData' },
      { _name: 'close' },
      { _name: 'closed' },
      { _name: 'codePointAt' },
      { _name: 'colorDepth' },
      { _name: 'compile' },
      { _name: 'complete' },
      { _name: 'components' },
      { _name: 'concat' },
      { _name: 'confirm' },
      { _name: 'console' },
      { _name: 'const' },
      { _name: 'constructor' },
      { _name: 'contains' },
      { _name: 'contextual' },
      { _name: 'continue' },
      { _name: 'controllers' },
      { _name: 'cookie' },
      { _name: 'cookieEnabled' },
      { _name: 'cos' },
      { _name: 'cpuClass' },
      { _name: 'createDocumentFragment' },
      { _name: 'createElement' },
      { _name: 'createEventObject' },
      { _name: 'createObjectURL' },
      { _name: 'createPopup' },
      { _name: 'createStyleSheet' },
      { _name: 'createTextNode' },
      { _name: 'credentials' },
      { _name: 'crypto' },
      { _name: 'current' },
      { _name: 'data' },
      { _name: 'dataset' },
      { _name: 'Date' },
      { _name: 'debugger' },
      { _name: 'default' },
      { _name: 'defaultCharset' },
      { _name: 'defaultChecked' },
      { _name: 'defaultStatus' },
      { _name: 'defaultValue' },
      { _name: 'defaultView' },
      { _name: 'delete' },
      { _name: 'description' },
      { _name: 'detachEvent' },
      { _name: 'dialogArguments' },
      { _name: 'dialogHeight' },
      { _name: 'dialogLeft' },
      { _name: 'dialogTop' },
      { _name: 'dialogWidth' },
      { _name: 'dir' },
      { _name: 'directories' },
      { _name: 'disableExternalCapture' },
      { _name: 'disconnect' },
      { _name: 'dispatchEvent' },
      { _name: 'display' },
      { _name: 'do' },
      { _name: 'doctype' },
      { _name: 'document' },
      { _name: 'documentElement' },
      { _name: 'domain' },
      { _name: 'DOMContentLoaded' },
      { _name: 'DOMParser' },
      { _name: 'double' },
      { _name: 'dump' },
      { _name: 'E' },
      { _name: 'elementFromPoint' },
      { _name: 'elements' },
      { _name: 'else' },
      { _name: 'embeds' },
      { _name: 'enabledPlugin' },
      { _name: 'enableExternalCapture' },
      { _name: 'encodeURI' },
      { _name: 'encodeURIComponent' },
      { _name: 'encoding' },
      { _name: 'enum' },
      { _name: 'entries' },
      { _name: 'escape' },
      { _name: 'eval' },
      { _name: 'event' },
      { _name: 'exec' },
      { _name: 'execCommand' },
      { _name: 'execScript' },
      { _name: 'exp' },
      { _name: 'expando' },
      { _name: 'export' },
      { _name: 'extends' },
      { _name: 'external' },
      { _name: 'false' },
      { _name: 'fetch' },
      { _name: 'fgColor' },
      { _name: 'fileCreatedDate' },
      { _name: 'fileModifiedDate' },
      { _name: 'filename' },
      { _name: 'fileSize' },
      { _name: 'fileUpdatedDate' },
      { _name: 'FileUpload' },
      { _name: 'final' },
      { _name: 'finally' },
      { _name: 'find' },
      { _name: 'findAll' },
      { _name: 'firstChild' },
      { _name: 'fixed' },
      { _name: 'float' },
      { _name: 'floor' },
      { _name: 'focus' },
      { _name: 'fontcolor' },
      { _name: 'fontFamily' },
      { _name: 'fontsize' },
      { _name: 'fontSize' },
      { _name: 'fontWeight' },
      { _name: 'for' },
      { _name: 'forEach' },
      { _name: 'Form' },
      { _name: 'form' },
      { _name: 'formName' },
      { _name: 'forms' },
      { _name: 'forward' },
      { _name: 'Frame' },
      { _name: 'frameElement' },
      { _name: 'frames' },
      { _name: 'from' },
      { _name: 'fromCharCode' },
      { _name: 'Function' },
      { _name: 'function' },
      { _name: 'getAllResponseHeaders' },
      { _name: 'getAttention' },
      { _name: 'getAttribute' },
      { _name: 'getAttributeNS' },
      { _name: 'getAttributeNode' },
      { _name: 'getAttributeNodeNS' },
      { _name: 'getBoundingClientRect' },
      { _name: 'getClientRects' },
      { _name: 'getComputedStyle' },
      { _name: 'getDate' },
      { _name: 'getDay' },
      { _name: 'getElementById' },
      { _name: 'getElementsByClassName' },
      { _name: 'getElementsByName' },
      { _name: 'getElementsByTagName' },
      { _name: 'getElementsByTagNameNS' },
      { _name: 'getFullYear' },
      { _name: 'getHours' },
      { _name: 'getMilliseconds' },
      { _name: 'getMinutes' },
      { _name: 'getMonth' },
      { _name: 'getSeconds' },
      { _name: 'getSelection' },
      { _name: 'getResponseHeader' },
      { _name: 'getTime' },
      { _name: 'getTimezoneOffset' },
      { _name: 'getUTCDate' },
      { _name: 'getUTCDay' },
      { _name: 'getUTCFullYear' },
      { _name: 'getUTCHours' },
      { _name: 'getUTCMilliseconds' },
      { _name: 'getUTCMinutes' },
      { _name: 'getUTCMonth' },
      { _name: 'getUTCSeconds' },
      { _name: 'getYear' },
      { _name: 'global' },
      { _name: 'go' },
      { _name: 'goto' },
      { _name: 'handleEvent' },
      { _name: 'hasAttribute' },
      { _name: 'hasAttributeNS' },
      { _name: 'hasAttributes' },
      { _name: 'hasFocus' },
      { _name: 'hash' },
      { _name: 'height' },
      { _name: 'Hidden' },
      { _name: 'history' },
      { _name: 'History' },
      { _name: 'home' },
      { _name: 'host' },
      { _name: 'hostname' },
      { _name: 'href' },
      { _name: 'hspace' },
      { _name: 'ids' },
      { _name: 'if' },
      { _name: 'ignoreCase' },
      { _name: 'Image' },
      { _name: 'images' },
      { _name: 'implementation' },
      { _name: 'implements' },
      { _name: 'import' },
      { _name: 'in' },
      { _name: 'includes' },
      { _name: 'index' },
      { _name: 'indexOf' },
      { _name: 'Infinity' },
      { _name: 'innerHTML' },
      { _name: 'innerHeight' },
      { _name: 'innerText' },
      { _name: 'innerWidth' },
      { _name: 'input' },
      { _name: 'insertBefore' },
      { _name: 'instanceof' },
      { _name: 'int' },
      { _name: 'interface' },
      { _name: 'IntersectionObserver' },
      { _name: 'isFinite' },
      { _name: 'isNaN' },
      { _name: 'italics' },
      { _name: 'java' },
      { _name: 'JavaArray' },
      { _name: 'JavaClass' },
      { _name: 'javaEnabled' },
      { _name: 'JavaObject' },
      { _name: 'JavaPackage' },
      { _name: 'join' },
      { _name: 'keys' },
      { _name: 'language' },
      { _name: 'lastChild' },
      { _name: 'lastElementChild' },
      { _name: 'lastIndex' },
      { _name: 'lastIndexOf' },
      { _name: 'lastMatch' },
      { _name: 'lastModified' },
      { _name: 'lastParen' },
      { _name: 'Layer' },
      { _name: 'layers' },
      { _name: 'layerX' },
      { _name: 'left' },
      { _name: 'leftContext' },
      { _name: 'length' },
      { _name: 'lengthComputable' },
      { _name: 'let' },
      { _name: 'lineHeight' },
      { _name: 'link' },
      { _name: 'Link' },
      { _name: 'linkColor' },
      { _name: 'links' },
      { _name: 'listStyleType' },
      { _name: 'LN10' },
      { _name: 'LN2' },
      { _name: 'load' },
      { _name: 'loaded' },
      { _name: 'localName' },
      { _name: 'Location' },
      { _name: 'location' },
      { _name: 'locationbar' },
      { _name: 'log' },
      { _name: 'LOG10E' },
      { _name: 'LOG2E' },
      { _name: 'long' },
      { _name: 'lowsrc' },
      { _name: 'marginBottom' },
      { _name: 'marginLeft' },
      { _name: 'marginRight' },
      { _name: 'margins' },
      { _name: 'marginTop' },
      { _name: 'match' },
      { _name: 'matches' },
      { _name: 'matchesSelector' },
      { _name: 'Math' },
      { _name: 'max' },
      { _name: 'MAX_VALUE' },
      { _name: 'media' },
      { _name: 'menubar' },
      { _name: 'mergeAttributes' },
      { _name: 'method' },
      { _name: 'MimeType' },
      { _name: 'mimeTypes' },
      { _name: 'min' },
      { _name: 'MIN_VALUE' },
      { _name: 'moveAbove' },
      { _name: 'moveBelow' },
      { _name: 'moveBy' },
      { _name: 'moveTo' },
      { _name: 'moveToAbsolute' },
      { _name: 'multiline' },
      { _name: 'name' },
      { _name: 'nameProp' },
      { _name: 'namespaces' },
      { _name: 'namespaceURI' },
      { _name: 'NaN' },
      { _name: 'native' },
      { _name: 'navigate' },
      { _name: 'navigator' },
      { _name: 'NEGATIVE_INFINITY' },
      { _name: 'netscape' },
      { _name: 'new' },
      { _name: 'next' },
      { _name: 'nextSibling' },
      { _name: 'nodeName' },
      { _name: 'nodeType' },
      { _name: 'nodeValue' },
      { _name: 'null' },
      { _name: 'Number' },
      { _name: 'Object' },
      { _name: 'observe' },
      { _name: 'of' },
      { _name: 'offscreenBuffering' },
      { _name: 'onabort' },
      { _name: 'onactivate' },
      { _name: 'onafterprint' },
      { _name: 'onafterupdate' },
      { _name: 'onbeforeactivate' },
      { _name: 'onbeforecut' },
      { _name: 'onbeforedeactivate' },
      { _name: 'onbeforeeditfocus' },
      { _name: 'onbeforepaste' },
      { _name: 'onbeforeprint' },
      { _name: 'onbeforeunload' },
      { _name: 'onbeforeupdate' },
      { _name: 'onblur' },
      { _name: 'oncellchange' },
      { _name: 'onchange' },
      { _name: 'onclick' },
      { _name: 'onclose' },
      { _name: 'oncontextmenu' },
      { _name: 'oncontrolselect' },
      { _name: 'oncut' },
      { _name: 'ondataavailable' },
      { _name: 'ondatasetchanged' },
      { _name: 'ondatasetcomplete' },
      { _name: 'ondblclick' },
      { _name: 'ondeactivate' },
      { _name: 'ondrag' },
      { _name: 'ondragdrop' },
      { _name: 'ondragend' },
      { _name: 'ondragenter' },
      { _name: 'ondragleave' },
      { _name: 'ondragover' },
      { _name: 'ondragstart' },
      { _name: 'ondrop' },
      { _name: 'onerror' },
      { _name: 'onerrorupdate' },
      { _name: 'onfocus' },
      { _name: 'onhelp' },
      { _name: 'onkeydown' },
      { _name: 'onkeypress' },
      { _name: 'onkeyup' },
      { _name: 'onLine' },
      { _name: 'onload' },
      { _name: 'onloadstart' },
      { _name: 'onmousedown' },
      { _name: 'onmousemove' },
      { _name: 'onmouseout' },
      { _name: 'onmouseover' },
      { _name: 'onmouseup' },
      { _name: 'onpaste' },
      { _name: 'onpropertychange' },
      { _name: 'onprogress' },
      { _name: 'onreadystatechange' },
      { _name: 'onreset' },
      { _name: 'onresize' },
      { _name: 'onresizeend' },
      { _name: 'onresizestart' },
      { _name: 'onrowenter' },
      { _name: 'onrowexit' },
      { _name: 'onrowsdelete' },
      { _name: 'onrowsinserted' },
      { _name: 'onscroll' },
      { _name: 'onselect' },
      { _name: 'onselectionchange' },
      { _name: 'onselectstart' },
      { _name: 'onstop' },
      { _name: 'onsubmit' },
      { _name: 'ontimeout' },
      { _name: 'onunload' },
      { _name: 'open' },
      { _name: 'opener' },
      { _name: 'opsProfile' },
      { _name: 'Option' },
      { _name: 'options' },
      { _name: 'oscpu' },
      { _name: 'outerHTML' },
      { _name: 'outerHeight' },
      { _name: 'outerWidth' },
      { _name: 'ownerDocument' },
      { _name: 'package' },
      { _name: 'Packages' },
      { _name: 'paddingBottom' },
      { _name: 'paddingLeft' },
      { _name: 'paddingRight' },
      { _name: 'paddings' },
      { _name: 'paddingTop' },
      { _name: 'pageX' },
      { _name: 'pageXOffset' },
      { _name: 'pageY' },
      { _name: 'pageYOffset' },
      { _name: 'parent' },
      { _name: 'parentElement' },
      { _name: 'parentLayer' },
      { _name: 'parentNode' },
      { _name: 'parentWindow' },
      { _name: 'parse' },
      { _name: 'parseFloat' },
      { _name: 'parseFromString' },
      { _name: 'parseInt' },
      { _name: 'Password' },
      { _name: 'pathname' },
      { _name: 'personalbar' },
      { _name: 'PI' },
      { _name: 'pixelDepth' },
      { _name: 'pkcs11' },
      { _name: 'plain' },
      { _name: 'platform' },
      { _name: 'Plugin' },
      { _name: 'plugins' },
      { _name: 'plugins.refresh' },
      { _name: 'pop' },
      { _name: 'port' },
      { _name: 'POSITIVE_INFINITY' },
      { _name: 'pow' },
      { _name: 'preference' },
      { _name: 'prefix' },
      { _name: 'preventDefault' },
      { _name: 'previous' },
      { _name: 'previousSibling' },
      { _name: 'print' },
      { _name: 'private' },
      { _name: 'product' },
      { _name: 'productSub' },
      { _name: 'prompt' },
      { _name: 'prompter' },
      { _name: 'protected' },
      { _name: 'protocol' },
      { _name: 'prototype' },
      { _name: 'public' },
      { _name: 'push' },
      { _name: 'queryCommandEnabled' },
      { _name: 'queryCommandIndeterm' },
      { _name: 'queryCommandState' },
      { _name: 'queryCommandValue' },
      { _name: 'querySelector' },
      { _name: 'querySelectorAll' },
      { _name: 'Radio' },
      { _name: 'random' },
      { _name: 'readyState' },
      { _name: 'recalc' },
      { _name: 'referrer' },
      { _name: 'RegExp' },
      { _name: 'releaseCapture' },
      { _name: 'releaseEvents' },
      { _name: 'reload' },
      { _name: 'removeAttribute' },
      { _name: 'removeAttributeNS' },
      { _name: 'removeAttributeNode' },
      { _name: 'removeChild' },
      { _name: 'removeEventListener' },
      { _name: 'replace' },
      { _name: 'Reset' },
      { _name: 'reset' },
      { _name: 'resizeBy' },
      { _name: 'resizeTo' },
      { _name: 'response' },
      { _name: 'responseText' },
      { _name: 'responseType' },
      { _name: 'responseXML' },
      { _name: 'return' },
      { _name: 'returnValue' },
      { _name: 'reverse' },
      { _name: 'revokeObjectURL' },
      { _name: 'right' },
      { _name: 'rightContext' },
      { _name: 'root' },
      { _name: 'rootMargin' },
      { _name: 'round' },
      { _name: 'routeEvents' },
      { _name: 'savePreferences' },
      { _name: 'screen' },
      { _name: 'screenLeft' },
      { _name: 'screenTop' },
      { _name: 'screenX' },
      { _name: 'screenY' },
      { _name: 'scripts' },
      { _name: 'scroll' },
      { _name: 'scrollbars' },
      { _name: 'scrollBy' },
      { _name: 'scrollByLines' },
      { _name: 'scrollByPages' },
      { _name: 'scrollHeight' },
      { _name: 'scrollLeft' },
      { _name: 'scrollTop' },
      { _name: 'scrollTo' },
      { _name: 'scrollWidth' },
      { _name: 'scrollX' },
      { _name: 'scrollY' },
      { _name: 'search' },
      { _name: 'security' },
      { _name: 'securityPolicy' },
      { _name: 'send' },
      { _name: 'Select' },
      { _name: 'select' },
      { _name: 'selected' },
      { _name: 'selectedIndex' },
      { _name: 'selection' },
      { _name: 'self' },
      { _name: 'Set' },
      { _name: 'setActive' },
      { _name: 'setAttribute' },
      { _name: 'setAttributeNS' },
      { _name: 'setAttributeNode' },
      { _name: 'setAttributeNodeNS' },
      { _name: 'setCursor' },
      { _name: 'setDate' },
      { _name: 'setFullYear' },
      { _name: 'setHotKeys' },
      { _name: 'setHours' },
      { _name: 'setInterval' },
      { _name: 'setMilliseconds' },
      { _name: 'setMinutes' },
      { _name: 'setMonth' },
      { _name: 'setRequestHeader' },
      { _name: 'setResizable' },
      { _name: 'setSeconds' },
      { _name: 'setTime' },
      { _name: 'setTimeout' },
      { _name: 'setUTCDate' },
      { _name: 'setUTCFullYear' },
      { _name: 'setUTCHours' },
      { _name: 'setUTCMilliseconds' },
      { _name: 'setUTCMinutes' },
      { _name: 'setUTCMonth' },
      { _name: 'setUTCSeconds' },
      { _name: 'setYear' },
      { _name: 'setZOptions' },
      { _name: 'shift' },
      { _name: 'short' },
      { _name: 'showHelp' },
      { _name: 'showModalDialog' },
      { _name: 'showModelessDialog' },
      { _name: 'siblingAbove' },
      { _name: 'siblingBelow' },
      { _name: 'sidebar' },
      { _name: 'signText' },
      { _name: 'sin' },
      { _name: 'sizeToContent' },
      { _name: 'slice' },
      { _name: 'small' },
      { _name: 'sort' },
      { _name: 'source' },
      { _name: 'splice' },
      { _name: 'split' },
      { _name: 'sqrt' },
      { _name: 'SQRT1_2' },
      { _name: 'SQRT2' },
      { _name: 'src' },
      { _name: 'static' },
      { _name: 'status' },
      { _name: 'statusbar' },
      { _name: 'stop' },
      { _name: 'strike' },
      { _name: 'String' },
      { _name: 'Style' },
      { _name: 'styleSheets' },
      { _name: 'sub' },
      { _name: 'Submit' },
      { _name: 'submit' },
      { _name: 'substr' },
      { _name: 'substring' },
      { _name: 'suffixes' },
      { _name: 'sun' },
      { _name: 'sup' },
      { _name: 'super' },
      { _name: 'switch' },
      { _name: 'synchronized' },
      { _name: 'systemLanguage' },
      { _name: 'tags' },
      { _name: 'taint' },
      { _name: 'taintEnabled' },
      { _name: 'takeRecords' },
      { _name: 'tan' },
      { _name: 'target' },
      { _name: 'test' },
      { _name: 'Text' },
      { _name: 'text' },
      { _name: 'textAlign' },
      { _name: 'Textarea' },
      { _name: 'textContent' },
      { _name: 'textDecoration' },
      { _name: 'textIndent' },
      { _name: 'textTransform' },
      { _name: 'then' },
      { _name: 'this' },
      { _name: 'thresholds' },
      { _name: 'throw' },
      { _name: 'throws' },
      { _name: 'time' },
      { _name: 'timeEnd' },
      { _name: 'title' },
      { _name: 'toGMTString' },
      { _name: 'toLocaleString' },
      { _name: 'toLowerCase' },
      { _name: 'toolbar' },
      { _name: 'top' },
      { _name: 'total' },
      { _name: 'toSource' },
      { _name: 'toString' },
      { _name: 'toUpperCase' },
      { _name: 'toUTCString' },
      { _name: 'transient' },
      { _name: 'true' },
      { _name: 'try' },
      { _name: 'type' },
      { _name: 'typeof' },
      { _name: 'undefined' },
      { _name: 'unescape' },
      { _name: 'uniqueID' },
      { _name: 'unobserve' },
      { _name: 'unshift' },
      { _name: 'untaint' },
      { _name: 'unwatch' },
      { _name: 'updateCommands' },
      { _name: 'updateInterval' },
      { _name: 'upload' },
      { _name: 'URL' },
      { _name: 'URLUnencoded' },
      { _name: 'userAgent' },
      { _name: 'userLanguage' },
      { _name: 'userProfile' },
      { _name: 'UTC' },
      { _name: 'value' },
      { _name: 'valueOf' },
      { _name: 'var' },
      { _name: 'vendor' },
      { _name: 'vendorSub' },
      { _name: 'visibility' },
      { _name: 'vLinkcolor' },
      { _name: 'void' },
      { _name: 'volatile' },
      { _name: 'vspace' },
      { _name: 'watch' },
      { _name: 'while' },
      { _name: 'whiteSpace' },
      { _name: 'width' },
      { _name: 'window' },
      { _name: 'with' },
      { _name: 'write' },
      { _name: 'writeln' },
      { _name: 'x' },
      { _name: 'XMLDocument' },
      { _name: 'XMLHttpRequest' },
      { _name: 'XSLDocument' },
      { _name: 'y' },
      { _name: 'zIndex' },
      { _name: '_content' }
    ]
  },
  {
    name: 'css',
    list: [
      {
        _name: 'display'
      },
      {
        _name: 'color'
      },
      {
        _name: 'background'
      },
      {
        _name: 'font-size'
      },
      {
        _name: 'position'
      },
      {
        _name: 'block'
      },
      {
        _name: 'none'
      },
      {
        _name: 'border'
      },
      {
        _name: 'outline'
      },
      {
        _name: 'fixed'
      },
      {
        _name: 'static'
      },
      {
        _name: 'relative'
      },
      {
        _name: 'absolute'
      },
      {
        _name: 'padding'
      },
      {
        _name: 'margin'
      },
      {
        _name: 'height'
      },
      {
        _name: 'width'
      },
      {
        _name: 'overflow'
      },
      {
        _name: 'translate'
      },
      {
        _name: 'scale'
      },
      {
        _name: 'opacity'
      },
      {
        _name: 'transition'
      },
      {
        _name: 'transform'
      },
      {
        _name: 'border'
      },
      {
        _name: 'border-radius'
      },
      {
        _name: 'padding-left'
      },
      {
        _name: 'padding-right'
      },
      {
        _name: 'padding-top'
      },
      {
        _name: 'padding-bottom'
      },
      {
        _name: 'margin-left'
      },
      {
        _name: 'margin-right'
      },
      {
        _name: 'margin-top'
      },
      {
        _name: 'margin-bottom'
      },
      {
        _name: 'z-index'
      },
      {
        _name: 'background-color'
      },
      {
        _name: 'background-image'
      },
      {
        _name: 'min-width'
      },
      {
        _name: 'min-height'
      },
      {
        _name: 'inline'
      },
      {
        _name: 'inline-block'
      },
      {
        _name: 'box-shadow'
      },
      {
        _name: 'cursor'
      },
      {
        _name: 'pointer'
      },
      {
        _name: ':hover'
      },
      {
        _name: ':active'
      },
      {
        _name: '::after'
      },
      {
        _name: '::before'
      }
    ]
  }
]
